From 97891f424cb2edb4d291362a742f869f9423fe36 Mon Sep 17 00:00:00 2001
From: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Date: Wed, 14 Nov 2018 11:29:47 +0530
Subject: [PATCH 08/14] mistral: Add eMMC support

Enable eMMC support on Mistral.

Change-Id: I59230c5503982c18fce20f748e3e917b86b5604e
Signed-off-by: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Signed-off-by: Nitheesh Sekar <nsekar@codeaurora.org>
---
 board/mistral/defconfig   |  4 ++++
 src/board/mistral/board.c | 22 ++++++++++++++++++++++
 2 files changed, 26 insertions(+)

diff --git a/board/mistral/defconfig b/board/mistral/defconfig
index 471ece7db25c..c86aa902ccc0 100644
--- a/board/mistral/defconfig
+++ b/board/mistral/defconfig
@@ -24,5 +24,9 @@ CONFIG_KERNEL_FIT_FDT_ADDR=0xB0000000
 #CONFIG_DRIVER_TPM_SPI is not set
 CONFIG_DRIVER_FLASH_SPI=y
 CONFIG_DRIVER_INPUT_USB=y
+#eMMC/SD-card
+CONFIG_DRIVER_STORAGE_MMC=y
+CONFIG_DRIVER_SDHCI=y
+CONFIG_DRIVER_STORAGE_SDHCI_MSM=y
 
 # VIDEO
diff --git a/src/board/mistral/board.c b/src/board/mistral/board.c
index b3b3369c2dc4..81b3f01a1fbd 100644
--- a/src/board/mistral/board.c
+++ b/src/board/mistral/board.c
@@ -25,6 +25,14 @@
 #include "boot/fit.h"
 #include "drivers/bus/usb/usb.h"
 #include "drivers/power/psci.h"
+#include "drivers/storage/sdhci_msm.h"
+
+#define TLMM_BOOT_SEL		0x010C1000
+#define EMMC_BOOT		0x8000000
+#define SDC1_HC_BASE		0x07804000
+#define SDC1_TLMM_CFG_ADDR	0x10C2000
+#define SDC1_MAX_CLK		1000000000
+
 
 static const VpdDeviceTreeMap vpd_dt_map[] = {
 	{ "cherokee_mac", "/soc@0/wifi@a000000/local-mac-address" },
@@ -84,6 +92,20 @@ static int board_setup(void)
 
 	list_insert_after(&ipq_enet_fixup.list_node, &device_tree_fixups);
 
+	/* eMMC support */
+	/* DATA pins are muxed between NAND and EMMC, configure them to eMMC */
+	writel(EMMC_BOOT, (uint32_t *)TLMM_BOOT_SEL);
+
+	SdhciHost *emmc = new_sdhci_msm_host((void *)SDC1_HC_BASE,
+					SDHCI_PLATFORM_EMMC_1V8_POWER |
+					SDHCI_PLATFORM_NO_EMMC_HS200,
+					SDC1_MAX_CLK,
+					(void *)SDC1_TLMM_CFG_ADDR,
+					NULL);
+	assert(emmc);
+	list_insert_after(&emmc->mmc_ctrlr.ctrlr.list_node,
+			&fixed_block_dev_controllers);
+
 	return 0;
 }
 
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

